public inbox for gcc-patches@gcc.gnu.org
 help / color / mirror / Atom feed
From: dnovillo@google.com (Diego Novillo)
To: reply@codereview.appspotmail.com, gchare@google.com,
	crowl@google.com,        gcc-patches@gcc.gnu.org
Subject: [pph] New script to reproduce failures from a .log file (issue4601050)
Date: Thu, 09 Jun 2011 18:40:00 -0000	[thread overview]
Message-ID: <20110609174910.F3F741DA1CD@topo.tor.corp.google.com> (raw)

This small script searches for the spawn line corresponding to a given
grep pattern inside a dejagnu log file.  If it finds the spawn line,
it executes it with any other arguments provided on the command line.

It's generally useful for cutting and pasting failed test cases.  I did
not find anything close to it in gcc/contrib, so I will be adding it
to trunk shortly.

Gab, Lawrence, this ought to simplify reproducing pph failures from
g++.log.  Feel free to add more functionality to it, or use it to
find writer and reader pairs in the log file and execute them separately.


Diego.


	* repro_fail: New.

diff --git a/contrib/repro_fail b/contrib/repro_fail
new file mode 100755
index 0000000..d5bce04
--- /dev/null
+++ b/contrib/repro_fail
@@ -0,0 +1,49 @@
+#!/bin/bash
+#
+# Script to reproduce a test failure from a dejagnu .log file
+#
+# Contributed by Diego Novillo <dnovillo@google.com>
+#
+# Copyright (C) 2011 Free Software Foundation, Inc.
+#
+# This file is part of GCC.
+#
+# GCC is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3, or (at your option)
+# any later version.
+#
+# GCC is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GCC; see the file COPYING.  If not, write to
+# the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+# Boston, MA 02110-1301, USA.
+
+if [ $# -lt 2 ] ; then
+    echo "usage: $0 pattern file.log [additional-args]"
+    echo
+    echo "Finds the 'spawn' line matching PATTERN in FILE.LOG and executes"
+    echo "the command with any arguments in ADDITIONAL-ARGS."
+    echo
+    exit 1
+fi
+
+set -e
+pattern=$1
+logf=$2
+shift 2
+args="$@"
+line=$(grep "^spawn .*$pattern" $logf | sed -e "s:^spawn ::")
+
+if [ "$line" = "" ] ; then
+    echo "Could not find a spawn command for pattern $1"
+    exit 1
+fi
+
+set -x +e
+$line $args
+exit $?

--
This patch is available for review at http://codereview.appspot.com/4601050

             reply	other threads:[~2011-06-09 17:49 UTC|newest]

Thread overview: 4+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2011-06-09 18:40 Diego Novillo [this message]
2011-06-09 21:27 ` Lawrence Crowl
2011-06-09 22:08   ` Diego Novillo
2011-06-10  6:36   ` Alexandre Oliva

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20110609174910.F3F741DA1CD@topo.tor.corp.google.com \
    --to=dnovillo@google.com \
    --cc=crowl@google.com \
    --cc=gcc-patches@gcc.gnu.org \
    --cc=gchare@google.com \
    --cc=reply@codereview.appspotmail.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).